#pragma once

// [lexeme-parser.h]
// -------------------------------------------------------------------------------------------- //
// lexeme parser static class
// -------------------------------------------------------------------------------------------- //

#include "lexeme-list.h"


namespace scm
{

	class LexemeParser {
	public:
		
		// run --> get lexeme list
		// -------------------------------------------------------------------------------------------- //
		static bool run(const char* filename, LexemeList& list);
		// -------------------------------------------------------------------------------------------- //

	private:

		// parser state
		// -------------------------------------------------------------------------------------------- //
		enum STATE {
			IS_NULL,
			IS_COMMENT_LINE,
			IS_STRING,
			IS_NAME,
			IS_NUMBER,
			IS_FRAC_NUMBER,
			IS_EXP_NUMBER,
			IS_ASSIGNMENT,
			IS_LESS_THAN,
			IS_GREATER_THAN,
			IS_NOT_EQUAL,
			IS_LOGICAL_AND,
			IS_LOGICAL_OR,
		};
		// -------------------------------------------------------------------------------------------- //

		// -------------------------------------------------------------------------------------------- //
		LexemeParser();
		~LexemeParser();
		// -------------------------------------------------------------------------------------------- //
	};
}
// -------------------------------------------------------------------------------------------- //
